Skip to content
v2.276.0

CfnMethod L1 construct ​

The AWS::ApiGateway::Method resource creates API Gateway methods that define the parameters and body that clients must send in their requests.

Example ​

ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_apigateway as apigateway } from 'aws-cdk-lib';
const cfnMethod = new apigateway.CfnMethod(this, 'MyCfnMethod', {
  httpMethod: 'httpMethod',
  resourceId: 'resourceId',
  restApiId: 'restApiId',

  // the properties below are optional
  apiKeyRequired: false,
  authorizationScopes: ['authorizationScopes'],
  authorizationType: 'authorizationType',
  authorizerId: 'authorizerId',
  integration: {
    type: 'type',

    // the properties below are optional
    cacheKeyParameters: ['cacheKeyParameters'],
    cacheNamespace: 'cacheNamespace',
    connectionId: 'connectionId',
    connectionType: 'connectionType',
    contentHandling: 'contentHandling',
    credentials: 'credentials',
    integrationHttpMethod: 'integrationHttpMethod',
    integrationResponses: [{
      statusCode: 'statusCode',

      // the properties below are optional
      contentHandling: 'contentHandling',
      responseParameters: {
        responseParametersKey: 'responseParameters',
      },
      responseTemplates: {
        responseTemplatesKey: 'responseTemplates',
      },
      selectionPattern: 'selectionPattern',
    }],
    integrationTarget: 'integrationTarget',
    passthroughBehavior: 'passthroughBehavior',
    requestParameters: {
      requestParametersKey: 'requestParameters',
    },
    requestTemplates: {
      requestTemplatesKey: 'requestTemplates',
    },
    responseTransferMode: 'responseTransferMode',
    timeoutInMillis: 123,
    uri: 'uri',
  },
  methodResponses: [{
    statusCode: 'statusCode',

    // the properties below are optional
    responseModels: {
      responseModelsKey: 'responseModels',
    },
    responseParameters: {
      responseParametersKey: false,
    },
  }],
  operationName: 'operationName',
  requestModels: {
    requestModelsKey: 'requestModels',
  },
  requestParameters: {
    requestParametersKey: false,
  },
  requestValidatorId: 'requestValidatorId',
});
python
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_apigateway as apigateway

cfn_method = apigateway.CfnMethod(self, "MyCfnMethod",
    http_method="httpMethod",
    resource_id="resourceId",
    rest_api_id="restApiId",

    # the properties below are optional
    api_key_required=False,
    authorization_scopes=["authorizationScopes"],
    authorization_type="authorizationType",
    authorizer_id="authorizerId",
    integration=apigateway.CfnMethod.IntegrationProperty(
        type="type",

        # the properties below are optional
        cache_key_parameters=["cacheKeyParameters"],
        cache_namespace="cacheNamespace",
        connection_id="connectionId",
        connection_type="connectionType",
        content_handling="contentHandling",
        credentials="credentials",
        integration_http_method="integrationHttpMethod",
        integration_responses=[apigateway.CfnMethod.IntegrationResponseProperty(
            status_code="statusCode",

            # the properties below are optional
            content_handling="contentHandling",
            response_parameters={
                "response_parameters_key": "responseParameters"
            },
            response_templates={
                "response_templates_key": "responseTemplates"
            },
            selection_pattern="selectionPattern"
        )],
        integration_target="integrationTarget",
        passthrough_behavior="passthroughBehavior",
        request_parameters={
            "request_parameters_key": "requestParameters"
        },
        request_templates={
            "request_templates_key": "requestTemplates"
        },
        response_transfer_mode="responseTransferMode",
        timeout_in_millis=123,
        uri="uri"
    ),
    method_responses=[apigateway.CfnMethod.MethodResponseProperty(
        status_code="statusCode",

        # the properties below are optional
        response_models={
            "response_models_key": "responseModels"
        },
        response_parameters={
            "response_parameters_key": False
        }
    )],
    operation_name="operationName",
    request_models={
        "request_models_key": "requestModels"
    },
    request_parameters={
        "request_parameters_key": False
    },
    request_validator_id="requestValidatorId"
)
java
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.apigateway.*;

CfnMethod cfnMethod = CfnMethod.Builder.create(this, "MyCfnMethod")
        .httpMethod("httpMethod")
        .resourceId("resourceId")
        .restApiId("restApiId")

        // the properties below are optional
        .apiKeyRequired(false)
        .authorizationScopes(List.of("authorizationScopes"))
        .authorizationType("authorizationType")
        .authorizerId("authorizerId")
        .integration(IntegrationProperty.builder()
                .type("type")

                // the properties below are optional
                .cacheKeyParameters(List.of("cacheKeyParameters"))
                .cacheNamespace("cacheNamespace")
                .connectionId("connectionId")
                .connectionType("connectionType")
                .contentHandling("contentHandling")
                .credentials("credentials")
                .integrationHttpMethod("integrationHttpMethod")
                .integrationResponses(List.of(IntegrationResponseProperty.builder()
                        .statusCode("statusCode")

                        // the properties below are optional
                        .contentHandling("contentHandling")
                        .responseParameters(Map.of(
                                "responseParametersKey", "responseParameters"))
                        .responseTemplates(Map.of(
                                "responseTemplatesKey", "responseTemplates"))
                        .selectionPattern("selectionPattern")
                        .build()))
                .integrationTarget("integrationTarget")
                .passthroughBehavior("passthroughBehavior")
                .requestParameters(Map.of(
                        "requestParametersKey", "requestParameters"))
                .requestTemplates(Map.of(
                        "requestTemplatesKey", "requestTemplates"))
                .responseTransferMode("responseTransferMode")
                .timeoutInMillis(123)
                .uri("uri")
                .build())
        .methodResponses(List.of(MethodResponseProperty.builder()
                .statusCode("statusCode")

                // the properties below are optional
                .responseModels(Map.of(
                        "responseModelsKey", "responseModels"))
                .responseParameters(Map.of(
                        "responseParametersKey", false))
                .build()))
        .operationName("operationName")
        .requestModels(Map.of(
                "requestModelsKey", "requestModels"))
        .requestParameters(Map.of(
                "requestParametersKey", false))
        .requestValidatorId("requestValidatorId")
        .build();
csharp
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.APIGateway;

var cfnMethod = new CfnMethod(this, "MyCfnMethod", new CfnMethodProps {
    HttpMethod = "httpMethod",
    ResourceId = "resourceId",
    RestApiId = "restApiId",

    // the properties below are optional
    ApiKeyRequired = false,
    AuthorizationScopes = new [] { "authorizationScopes" },
    AuthorizationType = "authorizationType",
    AuthorizerId = "authorizerId",
    Integration = new IntegrationProperty {
        Type = "type",

        // the properties below are optional
        CacheKeyParameters = new [] { "cacheKeyParameters" },
        CacheNamespace = "cacheNamespace",
        ConnectionId = "connectionId",
        ConnectionType = "connectionType",
        ContentHandling = "contentHandling",
        Credentials = "credentials",
        IntegrationHttpMethod = "integrationHttpMethod",
        IntegrationResponses = new [] { new IntegrationResponseProperty {
            StatusCode = "statusCode",

            // the properties below are optional
            ContentHandling = "contentHandling",
            ResponseParameters = new Dictionary<string, string> {
                { "responseParametersKey", "responseParameters" }
            },
            ResponseTemplates = new Dictionary<string, string> {
                { "responseTemplatesKey", "responseTemplates" }
            },
            SelectionPattern = "selectionPattern"
        } },
        IntegrationTarget = "integrationTarget",
        PassthroughBehavior = "passthroughBehavior",
        RequestParameters = new Dictionary<string, string> {
            { "requestParametersKey", "requestParameters" }
        },
        RequestTemplates = new Dictionary<string, string> {
            { "requestTemplatesKey", "requestTemplates" }
        },
        ResponseTransferMode = "responseTransferMode",
        TimeoutInMillis = 123,
        Uri = "uri"
    },
    MethodResponses = new [] { new MethodResponseProperty {
        StatusCode = "statusCode",

        // the properties below are optional
        ResponseModels = new Dictionary<string, string> {
            { "responseModelsKey", "responseModels" }
        },
        ResponseParameters = new Dictionary<string, object> {
            { "responseParametersKey", false }
        }
    } },
    OperationName = "operationName",
    RequestModels = new Dictionary<string, string> {
        { "requestModelsKey", "requestModels" }
    },
    RequestParameters = new Dictionary<string, object> {
        { "requestParametersKey", false }
    },
    RequestValidatorId = "requestValidatorId"
});
go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"

cfnMethod := awscdk.Aws_apigateway.NewCfnMethod(this, jsii.String("MyCfnMethod"), &CfnMethodProps{
	HttpMethod: jsii.String("httpMethod"),
	ResourceId: jsii.String("resourceId"),
	RestApiId: jsii.String("restApiId"),

	// the properties below are optional
	ApiKeyRequired: jsii.Boolean(false),
	AuthorizationScopes: []*string{
		jsii.String("authorizationScopes"),
	},
	AuthorizationType: jsii.String("authorizationType"),
	AuthorizerId: jsii.String("authorizerId"),
	Integration: &IntegrationProperty{
		Type: jsii.String("type"),

		// the properties below are optional
		CacheKeyParameters: []*string{
			jsii.String("cacheKeyParameters"),
		},
		CacheNamespace: jsii.String("cacheNamespace"),
		ConnectionId: jsii.String("connectionId"),
		ConnectionType: jsii.String("connectionType"),
		ContentHandling: jsii.String("contentHandling"),
		Credentials: jsii.String("credentials"),
		IntegrationHttpMethod: jsii.String("integrationHttpMethod"),
		IntegrationResponses: []interface{}{
			&IntegrationResponseProperty{
				StatusCode: jsii.String("statusCode"),

				// the properties below are optional
				ContentHandling: jsii.String("contentHandling"),
				ResponseParameters: map[string]*string{
					"responseParametersKey": jsii.String("responseParameters"),
				},
				ResponseTemplates: map[string]*string{
					"responseTemplatesKey": jsii.String("responseTemplates"),
				},
				SelectionPattern: jsii.String("selectionPattern"),
			},
		},
		IntegrationTarget: jsii.String("integrationTarget"),
		PassthroughBehavior: jsii.String("passthroughBehavior"),
		RequestParameters: map[string]*string{
			"requestParametersKey": jsii.String("requestParameters"),
		},
		RequestTemplates: map[string]*string{
			"requestTemplatesKey": jsii.String("requestTemplates"),
		},
		ResponseTransferMode: jsii.String("responseTransferMode"),
		TimeoutInMillis: jsii.Number(123),
		Uri: jsii.String("uri"),
	},
	MethodResponses: []interface{}{
		&MethodResponseProperty{
			StatusCode: jsii.String("statusCode"),

			// the properties below are optional
			ResponseModels: map[string]*string{
				"responseModelsKey": jsii.String("responseModels"),
			},
			ResponseParameters: map[string]interface{}{
				"responseParametersKey": jsii.Boolean(false),
			},
		},
	},
	OperationName: jsii.String("operationName"),
	RequestModels: map[string]*string{
		"requestModelsKey": jsii.String("requestModels"),
	},
	RequestParameters: map[string]interface{}{
		"requestParametersKey": jsii.Boolean(false),
	},
	RequestValidatorId: jsii.String("requestValidatorId"),
})

Initializer ​

ts
new CfnMethod(scope: Construct, id: string, props: CfnMethodProps)
python
CfnMethod(scope: Construct, id: str, props: CfnMethodProps)
java
new CfnMethod(Construct scope, String id, CfnMethodProps props)
csharp
new CfnMethod(Construct scope, string id, CfnMethodProps props)
go
NewCfnMethod(Scope Construct, Id *string, Props CfnMethodProps)

Construct Props ​

apiKeyRequiredoptionalboolean | IResolvableapi_key_requiredoptionaltyping.Union[bool, IResolvable]apiKeyRequiredoptionalBooleanApiKeyRequiredoptionalboolApiKeyRequiredoptionalinterface{}#
A boolean flag specifying whether a valid ApiKey is required to invoke this method.
authorizationScopesoptionalstring[]authorization_scopesoptionaltyping.List[str]authorizationScopesoptionalList<String>AuthorizationScopesoptionalstring[]AuthorizationScopesoptional*[]*string#
A list of authorization scopes configured on the method.
notes

The scopes are used with a COGNITO_USER_POOLS authorizer to authorize the method invocation. The authorization works by matching the method scopes against the scopes parsed from the access token in the incoming request. The method invocation is authorized if any method scopes matches a claimed scope in the access token. Otherwise, the invocation is not authorized. When the method scope is configured, the client must provide an access token instead of an identity token for authorization purposes.

authorizationTypeoptionalstringauthorization_typeoptionalstrauthorizationTypeoptionalStringAuthorizationTypeoptionalstringAuthorizationTypeoptional*string#
The method's authorization type.
notes

This parameter is required. For valid values, see Method in the API Gateway API Reference .

If you specify the AuthorizerId property, specify CUSTOM or COGNITO_USER_POOLS for this property.

authorizerIdoptionalstring | IAuthorizerRefauthorizer_idoptionaltyping.Union[str, IAuthorizerRef]authorizerIdoptionalStringAuthorizerIdoptionalstringAuthorizerIdoptionalinterface{}#
The identifier of an authorizer to use on this method.

The method's authorization type must be CUSTOM or COGNITO_USER_POOLS .

httpMethodstringhttp_methodstrhttpMethodStringHttpMethodstringHttpMethod*stringrequired#
The method's HTTP verb.
integrationoptionalIResolvable | CfnMethod.IntegrationPropertyintegrationoptionaltyping.Union[IResolvable, IntegrationProperty]integrationoptionalIResolvableIntegrationoptionalIResolvableIntegrationoptionalinterface{}#
Represents an `HTTP` , `HTTP_PROXY` , `AWS` , `AWS_PROXY` , or Mock integration.
methodResponsesoptionalIResolvable | IResolvable | CfnMethod.MethodResponseProperty[]method_responsesoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, MethodResponseProperty]]]methodResponsesoptionalIResolvableMethodResponsesoptionalIResolvableMethodResponsesoptionalinterface{}#
Gets a method response associated with a given HTTP status code.
operationNameoptionalstringoperation_nameoptionalstroperationNameoptionalStringOperationNameoptionalstringOperationNameoptional*string#
A human-friendly operation identifier for the method.

For example, you can assign the operationName of ListPets for the GET /pets method in the PetStore example.

requestModelsoptionalIResolvable | { [key: string]: string }request_modelsoptionaltyping.Union[IResolvable, typing.Mapping[str, str]]requestModelsoptionalIResolvableRequestModelsoptionalIResolvableRequestModelsoptionalinterface{}#
A key-value map specifying data schemas, represented by Model resources, (as the mapped value) of the request payloads of given content types (as the mapping key).
requestParametersoptionalIResolvable | { [key: string]: boolean | IResolvable }request_parametersoptionaltyping.Union[IResolvable, typing.Mapping[str, typing.Union[bool, IResolvable]]]requestParametersoptionalIResolvableRequestParametersoptionalIResolvableRequestParametersoptionalinterface{}#
A key-value map defining required or optional method request parameters that can be accepted by API Gateway.
notes

A key is a method request parameter name matching the pattern of method.request.{location}.{name} , where location is querystring , path , or header and name is a valid and unique parameter name. The value associated with the key is a Boolean flag indicating whether the parameter is required ( true ) or optional ( false ). The method request parameter names defined here are available in Integration to be mapped to integration request parameters or templates.

requestValidatorIdoptionalstring | IRequestValidatorRefrequest_validator_idoptionaltyping.Union[str, IRequestValidatorRef]requestValidatorIdoptionalStringRequestValidatorIdoptionalstringRequestValidatorIdoptionalinterface{}#
The identifier of a RequestValidator for request validation.
resourceIdstring | IResourceRefresource_idtyping.Union[str, IResourceRef]resourceIdStringResourceIdstringResourceIdinterface{}required#
The Resource identifier for the MethodResponse resource.
restApiIdstring | IRestApiRefrest_api_idtyping.Union[str, IRestApiRef]restApiIdStringRestApiIdstringRestApiIdinterface{}required#
The string identifier of the associated RestApi.

Properties ​

apiKeyRequiredmay be undefinedboolean | IResolvableapi_key_requiredmay be undefinedtyping.Union[bool, IResolvable]apiKeyRequiredmay be undefinedBooleanApiKeyRequiredmay be undefinedboolApiKeyRequiredmay be undefinedinterface{}#
A boolean flag specifying whether a valid ApiKey is required to invoke this method.
authorizationScopesmay be undefinedstring[]authorization_scopesmay be undefinedtyping.List[str]authorizationScopesmay be undefinedList<String>AuthorizationScopesmay be undefinedstring[]AuthorizationScopesmay be undefined*[]*string#
A list of authorization scopes configured on the method.
authorizationTypemay be undefinedstringauthorization_typemay be undefinedstrauthorizationTypemay be undefinedStringAuthorizationTypemay be undefinedstringAuthorizationTypemay be undefined*string#
The method's authorization type.
authorizerIdmay be undefinedstringauthorizer_idmay be undefinedstrauthorizerIdmay be undefinedStringAuthorizerIdmay be undefinedstringAuthorizerIdmay be undefined*string#
The identifier of an authorizer to use on this method.
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#
The CloudFormation resource type name for this resource class.
Options for this resource, such as condition, update policy etc.
cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#
AWS resource type.
creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#
httpMethodstringhttp_methodstrhttpMethodStringHttpMethodstringHttpMethod*string#
The method's HTTP verb.
integrationmay be undefinedIResolvable | CfnMethod.IntegrationPropertyintegrationmay be undefinedtyping.Union[IResolvable, IntegrationProperty]integrationmay be undefinedIResolvableIntegrationmay be undefinedIResolvableIntegrationmay be undefinedinterface{}#
Represents an `HTTP` , `HTTP_PROXY` , `AWS` , `AWS_PROXY` , or Mock integration.
logicalIdstringlogical_idstrlogicalIdStringLogicalIdstringLogicalId*string#
The logical ID for this CloudFormation stack element.

The logical ID of the element is calculated from the path of the resource node in the construct tree.

To override this value, use overrideLogicalId(newLogicalId).

A reference to a Method resource.
methodResponsesmay be undefinedIResolvable | IResolvable | CfnMethod.MethodResponseProperty[]method_responsesmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, MethodResponseProperty]]]methodResponsesmay be undefinedIResolvableMethodResponsesmay be undefinedIResolvableMethodResponsesmay be undefinedinterface{}#
Gets a method response associated with a given HTTP status code.
nodeNodenodeNodenodeNodeNodeNodeNodeNode#
The tree node.
operationNamemay be undefinedstringoperation_namemay be undefinedstroperationNamemay be undefinedStringOperationNamemay be undefinedstringOperationNamemay be undefined*string#
A human-friendly operation identifier for the method.
refstringrefstrrefStringRefstringRef*string#
Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).

requestModelsmay be undefinedIResolvable | { [key: string]: string }request_modelsmay be undefinedtyping.Union[IResolvable, typing.Mapping[str, str]]requestModelsmay be undefinedIResolvableRequestModelsmay be undefinedIResolvableRequestModelsmay be undefinedinterface{}#
A key-value map specifying data schemas, represented by Model resources, (as the mapped value) of the request payloads of given content types (as the mapping key).
requestParametersmay be undefinedIResolvable | { [key: string]: boolean | IResolvable }request_parametersmay be undefinedtyping.Union[IResolvable, typing.Mapping[str, typing.Union[bool, IResolvable]]]requestParametersmay be undefinedIResolvableRequestParametersmay be undefinedIResolvableRequestParametersmay be undefinedinterface{}#
A key-value map defining required or optional method request parameters that can be accepted by API Gateway.
requestValidatorIdmay be undefinedstringrequest_validator_idmay be undefinedstrrequestValidatorIdmay be undefinedStringRequestValidatorIdmay be undefinedstringRequestValidatorIdmay be undefined*string#
The identifier of a RequestValidator for request validation.
resourceIdstringresource_idstrresourceIdStringResourceIdstringResourceId*string#
The Resource identifier for the MethodResponse resource.
restApiIdstringrest_api_idstrrestApiIdStringRestApiIdstringRestApiId*string#
The string identifier of the associated RestApi.
stackStackstackStackstackStackStackStackStackStack#
The stack in which this element is defined.

CfnElements must be defined within a stack scope (directly or indirectly).

Methods ​

addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#
Syntactic sugar for `addOverride(path, undefined)`.
1 parameter

Parameters

  • pathpathpathpathPath — The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#
Use `addResourceDependency` instead.

This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.

addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#
Use `addResourceDependency` instead.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.

addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#
Add a value to the CloudFormation Resource Metadata.
addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#
Adds an override to the synthesized CloudFormation resource.
notes · 2 parameters

To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).

If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.

To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.

For example,

typescript
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');

would add the overrides

json
"Properties": {
  "GlobalSecondaryIndexes": [
    {
      "Projection": {
        "NonKeyAttributes": [ "myattribute" ]
        ...
      }
      ...
    },
    {
      "ProjectionType": "INCLUDE"
      ...
    },
  ]
  ...
}

The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.

Parameters

  • pathpathpathpathPath — - The path of the property, you can use dot notation to override values in complex types.
  • valuevaluevaluevalueValue — - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#
Adds an override that deletes the value of a property from the resource definition.
1 parameter

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#
Adds an override to a resource property.

Syntactic sugar for addOverride("Properties.<...>", value).

2 parameters

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path of the property.
  • valuevaluevaluevalueValue — The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#
Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.

applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#
Sets the cross-stack reference strength for this resource.

When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.

1 parameter

Parameters

  • strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#
Sets the deletion policy of the resource based on the removal policy specified.
notes

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:

cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#
getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#
Returns a token for an runtime attribute of this resource.

Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.

1 parameter

Parameters

  • attributeNameattribute_nameattributeNameattributeNameAttributeName — The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#
Retrieve a value value from the CloudFormation Resource Metadata.
inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#
Examines the CloudFormation resource and discloses attributes.
1 parameter

Parameters

  • inspectorinspectorinspectorinspectorInspector — tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#
Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.

returns

Returns: The construct as a stack element or undefined if it is not a stack element.

isCfnMethod(x: any): boolean@staticmethod def is_cfn_method(x: Any) -> boolpublic static Boolean isCfnMethod(Object x)public static bool IsCfnMethod(object x)func IsCfnMethod(X interface{}) *boolstatic#
Checks whether the given object is a CfnMethod.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#
Check whether the given object is a CfnResource.
isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#
Checks if `x` is a construct.
notes · 1 parameter · returns

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters

  • xxxxX — Any object.

Returns: true if x is an object created from a class which extends Construct.

obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#
Retrieves an array of resources and stacks this resource depends on.

For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.

overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#
Overrides the auto-generated logical ID with a specific ID.
1 parameter

Parameters

  • newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId — The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#
Use `removeResourceDependency` instead

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#
Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#
Replaces one dependency with another.
2 parameters

Parameters

  • targettargettargettargetTarget — The dependency to replace.
  • newTargetnew_targetnewTargetnewTargetNewTarget — The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#
Returns a string representation of this construct.
returns

Returns: a string representation of this resource

with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#
Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.